#ifndef MASSREN_H
#define MASSREN_H

#include "oogtk.h"
#include "rencore.h"

class MassRenamer : public gtk::Application, public gtk::Builder
{
    // GtkBuilder shortcuts to widgets
    gtk::Entry *source_;
    gtk::Entry *dest_;
    gtk::Window *main_;
    gtk::FileChooserButton *dir_, *destdir_;
    gtk::ListStore *list_;
    gtk::ToggleButton *usedest_;

    // local widgets
    gtk::Pixbuf ok_pix_, ko_pix_, yes_pix_, no_pix_;
    // private variables
    RenCore rencore_;
    std::string actual_;

    // private member functions
    void populate_list(const RenCore::FileMap &);

    // callbacks
    void timer();
    void changed();
    void usedest_changed();
    void toggled(const std::string &);
    void rename();
    
public:
    MassRenamer(const std::string & = "");
};

#endif
