#ifndef OOCRIT_H__
#define OOCRIT_H__

/**
 * GG
 * Small package around gtk Mutex 
 */

#include <glib.h> 

namespace gtk {

class Mutex
{
    private:
        GStaticMutex mutex;
    public:
        Mutex() {	
            g_static_mutex_init(&mutex);
        }
        ~Mutex() { 
            g_static_mutex_free(&mutex);
        }
        void Lock() { 
            g_static_mutex_lock(&mutex);
        }
        void Unlock() { 
            g_static_mutex_unlock(&mutex);
        }

        // old CriticalSection api emulation
        void Enter() { Lock(); }
        void Leave() { Unlock(); }
};

class AutoMutex
{
    public:
        AutoMutex(Mutex & cs) : cs_(cs) { cs_.Lock(); };
        ~AutoMutex() { cs_.Unlock(); };
    private:
        Mutex & cs_;
};

}

#ifndef NO_CRITSECTION_EMUL
typedef gtk::Mutex CritSection;
typedef gtk::AutoMutex AutoCS;
#endif

#endif

