#ifndef RENCORE_H
#define RENCORE_H

#include <string>
#include <map>
#include <set>

class RenCore {
    std::string make_new_name(const std::string &);
    bool match_keys(const std::string &);

public:    
    typedef std::map<std::string, std::pair<std::string, int> > FileMap;
    typedef FileMap::const_iterator FileCIt;

    size_t key_size() const { return keys_.size(); }
    size_t cache_size() const { return files_.size(); }
    void build_file_cache(const std::string &dirname);
    void get_files(FileMap &);
    bool set_keys(const std::string &);
    void dest(const std::string &d) { dest_ = d; }
    bool perform (const FileMap &, std::string, std::string);
private:
    typedef std::map<std::string, int> CacheMap;
    typedef CacheMap::const_iterator CacheCIt;
    CacheMap files_;
    std::set<std::string> keys_;   
    std::string dest_;
};


#endif

